//
//  Ship.swift
//  GameBattleshipTerminal
//
//  Created by Piotr Fulmański on 2020.03.02.
//  Copyright © 2020 Piotr Fulmański. All rights reserved.
//

import Foundation

class Ship {
    private let size: Int
    private var readyLevel: Int
    var position: [(row: Int, col: Int, status: Status)]
    
    var isDestroyed: Bool {
        return readyLevel == 0 ? true : false
    }
    
    enum Direction {
        case up, down, left, right
    }
    
    enum Status {
        case damaged, ready, destroyed
    }
    
    init(size: Int,
         position: [(row: Int, col: Int, status: Status)]) {
        self.size = size
        self.position = position
        self.readyLevel = size
    }
    
    func hitAt(row: Int, col: Int) {
        for (index, coordinate) in position.enumerated() {
            if coordinate.row == row &&
                coordinate.col == col {
                position[index].status = Status.damaged
                readyLevel -= 1
                break
            }
        }
    }
    
    func isLocatedAt(row: Int, col: Int) -> Bool {
        for coordinate in position {
            if coordinate.row == row &&
                coordinate.col == col {
                return true
            }
        }
        
        return false
    }
    
}
